""" This is trickier than it seems at first sight!  If you remember that you can read any number by splitting it into blocks of three digits then it seems quite straightforward until you try to add the 'and's, commas and hyphens in the right places."""

from math import log10 as log
digits = (("","","ten","zero"),("one","ten", "eleven"),("two","twenty ", "twelve"),("three","thirty ","thirteen"),("four","forty ","fourteen"),("five","fifty ","fifteen"),("six","sixty ","sixteen"),("seven","seventy ","seventeen"),("eight","eighty ","eighteen"),("nine","ninety ","nineteen"))
suffix = ("",""," hundred ")
magnitude = (""," thousand"," million"," billion"," trillion"," quadrillion"," quintillion")

def words(number):
  minus = False
  output = ""
  # is it negative?
  if number < 0:
    minus = True
    number = abs(number)
  place = 0
  # find length of integer part
  if number > 0.5:
    place = int(log(number))
  teen = False
  text = ""
  # correctly set zeros is number isn't a multiple of three digits long
  zeros = (place % 3 == 0) * 6 + (place % 3 == 1) * 4
  while place >= 0:
    # current digit
    digit = int((number / 10**place) % 10)
    if digit == 0:
      # record absence of hundreds, tens or units
      zeros += (2**(place % 3))
      # is the integer part actually zero?
      if int(number) == 0:
        text = "zero"
    if digit == 1 and (place % 3) == 1:
      # if the tens digit is 1, look at the next digit
      teen = True
    else:
      # insert a hyphen where there are tens and units
      if (place % 3) == 0 and zeros & 3 == 0 and not teen:
        text = text[:-1] + "-"
      text += digits[digit][((place % 3) == 1) + teen*2]
      if zeros & 4 == 0:
        text += suffix[place % 3]
      teen = False
    # end of a cluster of three digits
    if (place % 3) == 0:
      if zeros & 4 == 0 and zeros & 3 < 3:
        # hundreds and units or tens needs an 'and'
        char = text.find("hundred") + 7
        text = text[:char] + " and " + text[char+1:]
      if place > 0 and zeros < 7:
        # add 'thousand', etc., if more than three digits
        text += magnitude[int(place/3)]
      if output > "" and zeros & 3 < 3 and zeros & 4 == 4 and place == 0:
        # thousands, no hundreds but tens or units needs an 'and'
        text = " and " + text
      elif output > "" and text > "":
        # add a comma if the cluster of three digits has a value
        output += ", "
      output += text
      text = ""
      zeros = 0
    place += -1
  if type(number) == float:
    output += " point"
    # process decimal part as text to avoid floating point errors
    number = str(number)
    number = number[number.find(".")+1:]
    for digit in number:
        output += " " + digits[int(digit)][(digit == "0")*3]
  if minus and number != 0:
    output = "minus " + output
  print(output)

cont = True
print("Enter something other than a number to stop...")
while cont:
  try:
    number = eval(input("\nGive me a number:"))
    words(number)
  except:
    cont = False