from re import match

def validate_registration(plate):
  # regular expression to match valid registration
  return (match(r"[A-Z][A-Z]\d\d\s[A-Z][A-Z][A-Z]", plate) != None)

def decimalise(time):
  times = time.split(":")
  return float(times[0]) + float(times[1])/60

def speed(start, end):
  if start >= end:
    end += 24
  return round(1/(end-start),2)

print("Please use the 24-hour clock for all times.")
start = input("Time at first camera (HH:MM): ")
end = input("Time at second camera (HH:MM): ")
plate = input("Registration? ")
print("Speed:", str(speed(decimalise(start),decimalise(end)))+"mph")
print("Valid registration:",validate_registration(plate))